<!DOCTYPE html>
    <html lang="fr">
    <head>
  		<meta charset=UTF-8>
  		<title>Inscription au service cloud - AutoMario</title>
  		<meta name="description" content="Projet d'hébergement participatif et décentralisé, fournissant un ensemble de services pour particuliers et associations et basé sur des technologies et logiciels libres."/>
  		<meta name="keywords" content="CHATONS,mail,cloud,hébergement,libre"/>
  		<meta name="author" content="Vincent Finance"/>
  		<meta name="viewport" content="initial-scale=1.0"/>
  		<link rel="stylesheet" href="/css/site.css" type="text/css">
      <link rel="stylesheet" href="/css/inscription.css" type="text/css">
  		<link rel="icon" type="image/x-icon" href="/pictures/favicon.ico"/>
  		<meta name="generator" content="Nanoc 4.11.8">
  	</head>
    <body>
      <header>
        <picture>
          <img alt="Logo officiel du projet - Tête de pengouin en pixelart" src="/pictures/logo.png"/>
        </picture>
      </header>
<?php
    # *** LICENSE ***
    # You can redistribute it under the terms of the MIT Licence.
    # *** LICENSE ***
    # File to subscribe to an account

    /*

     !!! Le dossier /data doit être interdit dans la config du serveur !!!

     Si aucun argument :
     - Afficher un formulaire de contact qui propose le nom d'utilisateur, donne une adresse mail de contact en cas de problème
     - adresse mail souhaitée
     - mot de passe souhaité pour récupérer les identifiants
     - captcha

     - Le formulaire est envoyé au sysadmin avec une url aléatoire
     - Le script renvoie vers une page indiquant l'URL à suivre pour obtenir les informations sur le nouveau compte.

     Si argument :
     - Vérifier si le fichier en argument existe dans /data
     - Si oui, on affiche son contenu qui contient les identifiants avec un beau template, puis SUPPRIMER le fichier contenant les identifiants
     - Si non, indiquer que la création du compte n'est pas encore prête ou périmée.
     */

    session_start();

    $GLOBALS['mail_admin'] = 'linuxmario@automario.eu';
    $GLOBALS['subscribe_dir'] = '/cloud/';
    $GLOBALS['subscribe_page'] = $GLOBALS['subscribe_dir'] . 'form.php';
    $GLOBALS['nbname'] = array(
                               // Chiffres 0 à 16 pour captcha
                               '0' => 'zéro',
                               '1' => 'un',
                               '2' => 'deux',
                               '3' => 'trois',
                               '4' => 'quatre',
                               '5' => 'cinq',
                               '6' => 'six',
                               '7' => 'sept',
                               '8' => 'huit',
                               '9' => 'neuf',
                               '10' => 'dix',
                               '11' => 'onze',
                               '12' => 'douze',
                               '13' => 'treize',
                               '14' => 'quatorze',
                               '15' => 'quinze',
                               '16' => 'seize',
                               );
    ?>

<?php

    function random_str($length, $keyspace = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ')
    # https://stackoverflow.com/questions/4356289/php-random-string-generator/31107425#31107425
    {
        $keyspace = str_shuffle($keyspace );
        $str = '';
        $max = mb_strlen($keyspace, '8bit') - 1;
        for ($i = 0; $i < $length; ++$i) {
            $str .= $keyspace[random_int(0, $max)];
        }
        return $str;
    }

    function captcha()
    /* Invent captcha
     return calculus string
     store expected result in _SESSION */
    {
        $v1 = rand(0,16);
        $v2 = rand(0,100);
        $_SESSION['captcha'] = $v1 + $v2;

        $str = $GLOBALS['nbname'][strval($v1)] . " + " . $v2 . " = ";

        return $str;
    }

    function show_form()
    {
        echo '<main>';
        echo '<div class="formel">';
        echo '<h1 id="inscription">Créer votre compte Nextcloud</h1>';
        echo '<form id="contact" class="formstyle" method="post" action="'.$GLOBALS['subscribe_page'].'">';
        echo '<ul>';
        echo '<li>';
        echo '<label for="name">Prénom et nom </label>';
        echo '<input type="text" required id="name" name="name" placeholder="Vladimir Komarov"/>';
        echo '</li>';
        echo '<li>';
        echo '<label for="user">Identifiant souhaité </label>';
        echo '<input type="text" required id="user" name="user" pattern="[a-zA-Z0-9]+" placeholder="vladimir" maxlength="42"/>';
        echo '</li>';
        echo '<li>';
        echo '<label for="rescuemail">Email de secours valide</label>';
        echo "<label>Attention, veuillez ne pas utiliser d'adresse mail temporaire et bien vérifier vos spams !</label>";
        echo '<input type="text" required id="rescuemail" name="rescuemail" placeholder="vladimir@secours.valide"/>';
        echo '</li>';
        echo '<li>';
        echo '<label for="captcha">Un petit calcul ? </label>';
        echo captcha() ;
        echo '<input type="number" required id="captcha" name="captcha" min="0" step="1" />';
        echo '</li>';
        echo '<input id="subscribe" type="submit" name="subscribe" value="Envoyer" />';
        echo '</ul>';
        echo '</form>';
        echo '</div>';
        echo '</main>';
    }

    /* Inscription demandée, on affiche la réponse */
    if (!empty($_POST["subscribe"])) {
        if ( $_SESSION['captcha'] != $_POST['captcha'] ) {
            echo "Petite erreur de calcul ?";
        }
        else
        {
            $user = '';
            $name = '';
            $rescuemail = '';
            $admin_email = $GLOBALS['mail_admin'];

            // formulaire envoyé, on récupère tous les champs.
            if (!empty($_POST["user"])) {
                $user = trim($_POST["user"]);
                $name = trim($_POST["name"]);
                $rescuemail = trim($_POST["rescuemail"]);
            }


            if ($user != '') {

                $random_file = random_str(rand(10,75));
                $random_page = $GLOBALS['subscribe_page'] . "?patate=" . $random_file;

                $headers  = 'MIME-Version: 1.0' . "\r\n";
                $headers .= 'From: <linuxmario@automario.eu>' . "\r\n" .
                'Reply-To: <linuxmario@automario.eu>' . "\r\n" .
                'Content-Type: text/plain; charset="utf-8"; DelSp="Yes"; format=flowed '."\r\n" .
                'Content-Disposition: inline'. "\r\n" .
                'Content-Transfer-Encoding: 7bit'." \r\n" .
                'X-Mailer:PHP/'.phpversion();

                $message = "Vous venez de recevoir une nouvelle demande d'inscription pour le service cloud\r\n";
                $message .= "\r\n";
                $message .= "- Prénom et nom de l'utilisateur : ".$name . "\r\n";
                $message .= "- Nom d'utilisateur demandé : ".$user . "\r\n";
                $message .= "- Email de secours : ".$rescuemail . "\r\n";
                $message .= "\r\n";
                $message .= "- Identifiants à enregistrer dans /srv/stockage/www/plateforme/cloud/data/".$random_file.".txt\r\n";
                $message .= "\r\n";
                $message .= "Marche à suivre :\r\n";
                $message .= "\r\n";
                $message .= "- Ajouter l'utilisateur via l'interface d'administration de Nextcloud\r\n";
                $message .= "- Générer un mot de passe aléatoire\r\n";
                $message .= "- Enregistrer les infos dans le fichier indiqué via SSH\r\n";


                // Envoi du mail
                if (mail($admin_email, 'Demande de nouvelle inscription Cloud', $message, $headers)) {
                    echo '<main>';
                    echo '<div class="formel">';
                    echo "<h2>Demande effectuée avec succès</h2>";
                    echo "<p>Votre demande est bien envoyée, l'admin va s'en occuper.</p>";
                    echo "<p>Après réception, l'administrateur vous enverra un mail contenant vos identifiants de connexion. Le mot de passe assigné est généré aléatoirement.<br/>Je vous invite à bien sauvegarder ces informations et à changer votre mot de passe rapidement ou à nous contacter par mail ou IRC en cas de problème.</p>";
                    echo "<p>Attention : selon votre hébergeur, les mails peuvent arriver dans votre boîte de messages indésirables. Je vous invite alors à vérifier cette boîte avant de me contacter pour tout problème de réception de vos identifiants.</p>";
                    echo '</div>';
                    echo '</main>';
                } else {
                    echo '<main>';
                    echo '<div class="formel">';
                    echo "<h2>Echec du traitement de votre demande</h2>";
                    echo "<p>Une erreur est survenue lors de l'envoi du message. Nous n'avons pas pu traiter votre demande d'inscription.</p>";
                    echo "<p>Nous vous invitons à réessayer plus tard ou à contacter l'administrateur par mail ou IRC si vous n'arrivez toujours pas à nous l'envoyer.</p>";
                    echo "<p>Nous nous excusons pour la gêne occasionnée.</p>";
                    echo '</div>';
                    echo '</main>';
                };
            }
        }
    }
    else {
        if ( isset($_GET["patate"])) {
            $fichier =  $_GET["patate"];
            if ( ! ctype_alnum($fichier)){
                echo "You are a bad guy!";
                die();
            }

            $path = './data/'.$fichier.'.txt';
            if (file_exists($path)) {
                // On récupère le contenu et supprime le fichier
                $content = file_get_contents($path);
                unlink($path);

                echo '<main>';
                echo '<div class="formel">';
                echo "<h2>Bienvenue sur automario.eu ☺</h2>";
                echo "<p>Vos identifiants sont : </p>";
                echo "<pre><code class='codevoid'>";

                echo $content;

                echo "</code></pre>";

                echo "<p>Ces informations sont déjà détruites, veillez à bien les conserver sur votre ordinateur !</p>";
                echo "<p>Vous pouvez modifier votre mot de passe via l'interface de votre espace Nextcloud.<br/>Nous vous invitons à nous contacter par mail ou IRC en cas de problème.</p>";
                echo "<p>Pour vous connecter, cliquez sur <a href=https://cloud.automario.eu>ce lien</a>.</p>";
                echo '</div>';
                echo '</main>';
            }
            else{
                echo '<main>';
                echo '<div class="formel">';
                echo "<h2>Votre compte n'est pas (encore) disponible</h2>";
                echo "<p>Il semble que votre compte ne soit pas encore prêt, ou bien le lien suivi est erroné ou périmé.</p>";
                echo "<p>Dans le premier cas, réessayez plus tard, l'admin traite votre demande.</p>";
                echo '</div>';
                echo '</main>';
            }


        }
        else {
            show_form();
        }
    }
    ?>
        <footer>
			<p>Généré via <a title="Générateur de sites en Ruby" target="_blank" rel="noopener noreferrer" href="http://nanoc.ws/about/">Nanoc</a> / Propulsé par <a href="https://debian.org/" rel="noopener noreferrer" target="_blank" title="Lien vers le site officiel de Debian">Debian</a> / Licence <a title="Lien vers la licence du projet" rel="noopener noreferrer" target="_blank" href="/licence.txt">MIT</a> / <a target="_blank" rel="noopener noreferrer" href="https://liberapay.com/linuxmario/donate">Soutenir le projet</a> / Photo by <a rel="noopener noreferrer" target="_blank" href="https://unsplash.com/@nate_dumlao?utm_source=unsplash&amp;utm_medium=referral&amp;utm_content=creditCopyText">Nathan Dumlao</a> on Unsplash</p>
	    </footer>
    </body>
</html>
